package com.perforce.workshop.tjuricek.p4java_ext;

class DefaultP4ClientConnection extends DefaultP4Connection implements P4ClientConnection {

    private String clientName;

    public DefaultP4ClientConnection(P4Connection conn, String clientName) {
        super(conn);
        this.clientName = clientName;
    }

    public DefaultP4ClientConnection(P4ClientConnection conn) {
        super(conn);
        setClientName(conn.getClientName());
    }

    @Override
    public String getClientName() {
        return clientName;
    }

    @Override
    public void setClientName(String name) {
        this.clientName = name;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;

        DefaultP4ClientConnection that = (DefaultP4ClientConnection) o;

        if (clientName != null ? !clientName.equals(that.clientName) : that.clientName != null)
            return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = super.hashCode();
        result = 31 * result + (clientName != null ? clientName.hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return "DefaultP4ClientConnection{" +
                "login='" + getLogin() + "'," +
                "clientName='" + clientName + '\'' +
                '}';
    }
}
