package com.perforce.workshop.tjuricek.p4java_ext;

/**
 * Any API call that requires a client with the user should depend upon this
 * interface.
 * <p/>
 * This should clarify which command interface implementations require clients
 * and which do not. It does require the implementer of this interface to
 * decide upon what client to use, which is not that simple.
 */
public interface P4ClientConnection extends P4Connection {

    static P4ClientConnection create(P4Connection conn, String clientName) {
        return new DefaultP4ClientConnection(conn, clientName);
    }

    static P4ClientConnection create(P4ClientConnection other) {
        return new DefaultP4ClientConnection(other);
    }

    /**
     * The client name in perforce. You should assume that the OptionsServer
     * instance returned is set to use this client.
     */
    String getClientName();

    void setClientName(String name);
}
